weka.gui.visualize

## Class PrintablePanel

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - weka.gui.visualize.PrintablePanel

- All Implemented Interfaces:
    java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, javax.accessibility.Accessible, PrintableHandler
  Direct Known Subclasses:
    AttributeVisualizationPanel, HierarchyVisualizer, TreeVisualizer, VisualizePanel

      public class PrintablePanel
      extends javax.swing.JPanel
      implements PrintableHandler

  This Panel enables the user to print the panel to various file formats. The Print dialog is accessible via Ctrl-Shft-Left Mouse Click.

  The individual JComponentWriter-descendants can be accessed by the `getWriter(String)` method, if the parameters need to be changed.

  Version:
    $Revision: 10222 $
  Author:
    FracPete (fracpete at waikato dot ac dot nz)
  See Also:
    `getWriters()`, `getWriter(String)`, Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.BaselineResizeBehavior`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JComponent

      `TOOL_TIP_TEXT_KEY, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PrintablePanel()` initializes the panel

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getSaveDialogTitle()` returns the title for the save dialog
    `JComponentWriter` | `getWriter(java.lang.String name)` returns the JComponentWriter associated with the given name, is `null` if not found
    `java.util.Hashtable<java.lang.String,JComponentWriter>` | `getWriters()` returns a Hashtable with the current available JComponentWriters in the save dialog.
    `double` | `getXScale()` returns the scale factor for the x-axis
    `double` | `getYScale()` returns the scale factor for the y-axis
    `void` | `saveComponent()` displays a save dialog for saving the panel to a file.
    `void` | `setSaveDialogTitle(java.lang.String title)` sets the title for the save dialog
    `void` | `setScale(double x, double y)` sets the scale factor

    - ### Methods inherited from class javax.swing.JPanel

      `getAccessibleContext, getUI, getUIClassID, setUI, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintImmediately, paintImmediately, print, printAll, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, contains, createImage, createImage, createVolatileImage, createVolatileImage, dispatchEvent, enable, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### PrintablePanel

          public PrintablePanel()

      initializes the panel

  - ### Method Detail

    - #### getWriters

          public java.util.Hashtable<java.lang.String,JComponentWriter> getWriters()

      returns a Hashtable with the current available JComponentWriters in the save dialog. the key of the Hashtable is the description of the writer.
      Specified by:
        `getWriters` in interface `PrintableHandler`
      Returns:
        all currently available JComponentWriters
      See Also:
        `JComponentWriter.getDescription()`

    - #### getWriter

          public JComponentWriter getWriter(java.lang.String name)

      returns the JComponentWriter associated with the given name, is `null` if not found
      Specified by:
        `getWriter` in interface `PrintableHandler`
      Returns:
        the writer associated with the given name
      See Also:
        `JComponentWriter.getDescription()`

    - #### setSaveDialogTitle

          public void setSaveDialogTitle(java.lang.String title)

      sets the title for the save dialog
      Specified by:
        `setSaveDialogTitle` in interface `PrintableHandler`

    - #### getSaveDialogTitle

          public java.lang.String getSaveDialogTitle()

      returns the title for the save dialog
      Specified by:
        `getSaveDialogTitle` in interface `PrintableHandler`

    - #### setScale

          public void setScale(double x,
                      double y)

      sets the scale factor
      Specified by:
        `setScale` in interface `PrintableHandler`
      Parameters:
        `x` - the scale factor for the x-axis
        `y` - the scale factor for the y-axis

    - #### getXScale

          public double getXScale()

      returns the scale factor for the x-axis
      Specified by:
        `getXScale` in interface `PrintableHandler`

    - #### getYScale

          public double getYScale()

      returns the scale factor for the y-axis
      Specified by:
        `getYScale` in interface `PrintableHandler`

    - #### saveComponent

          public void saveComponent()

      displays a save dialog for saving the panel to a file.
      Specified by:
        `saveComponent` in interface `PrintableHandler`